#ifndef __util_h__
#define __util_h__

#if !defined(__linux__) 
//typedef char  int8_t;
typedef short int16_t;
//typedef long  int32_t;
#endif

typedef unsigned char  uint8_t;
typedef unsigned short uint16_t;
//typedef unsigned long  uint32_t;

static inline int bit_is_set(uint8_t *datap, int off) {
	int pos = off % 8;
	datap += off / 8;
	return (*datap & (1 << pos)) != 0; // LSB first
}

static inline void bit_set(uint8_t *datap, int off) {
	int pos = off % 8;
	datap += off / 8;
	*datap |= (1 << pos);
}

static inline void bit_clear(uint8_t *datap, int off) {
	int pos = off % 8;
	datap += off / 8;
	*datap &= ~(1 << pos);
}
extern int bitcmp(uint8_t *a, int off_a, uint8_t *b, int off_b, int n_bits);

extern uint8_t rev[256];

void build_rev();
void dump(uint8_t *buf, uint32_t addr, int len, int rev_bit, FILE *fp);
double dtime();
#endif


extern void progress_start(char *msg, int total);
extern void progress(int cur);
extern void progress_stop();

