/*
 * Copyright (C) 2011 Koji Suzuki
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2.1 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

module spi_echo (
		input CLK
		, input MOSI
		, input SCK
		, input CS
		, output MISO

		, output [7:0] SPI_DATA
		);

    reg req_shift;
    reg r_sck = 1'b0;
    reg r_spi_in;
    reg [2:0]  r_count;
    reg [7:0]  r_spi;
    reg [7:0]  r_data; // recieved data

    assign SPI_DATA = r_data[7:0];
//    wire v_empty = (r_data[7:0] == 8'hff);
//    assign SPI_DATA = { 4'b0, ~v_empty , r_count[2:0] };

    assign MISO = r_spi[7];

    always @(negedge CLK)
    begin
	r_sck       <= SCK;

	if (~r_sck & SCK) // posedge SCK : INPUT
	    begin
		req_shift <= ~CS;
		if (CS) r_count    <= 0;
	    end
	else if (req_shift & r_sck & ~SCK) // negedge SCK : SHIFT
	    begin
		r_count <= r_count + 1;
		r_spi <= {r_spi[6:0], MOSI };
		if (r_count == 7)
		    begin
			r_data <= {r_spi[6:0], MOSI };
		    end
	    end
    end

endmodule
